
// example presented in paragraph 7.12 of the manual
// https://maniFEM.rd.ciencias.ulisboa.pt/manual-maniFEM.pdf
// a cube repeated in two directions of the space

#include "maniFEM.h"

using namespace maniFEM;


int main ()

{	Manifold RR3 ( tag::Euclid, tag::of_dim, 3 );
	Function xyz = RR3 .build_coordinate_system ( tag::Lagrange, tag::of_degree, 1 );
	Function x = xyz [0], y = xyz [1], z = xyz [2];

	// define three actions on RR3 (translations)
	Manifold::Action gx ( tag::transforms, xyz, tag::into, (x+2.) && y && z ),
	                 gy ( tag::transforms, xyz, tag::into, x && (y+2.) && z ),
	                 gz ( tag::transforms, xyz, tag::into, x && y && (z+2.) );
	
	// and divide RR3 by the group of translations generated by { gx, gy }
	Manifold torus_manif = RR3 .quotient ( gx, gy );

	const double r2 = 0.2;
	Manifold sphere = RR3 .implicit ( x*x + y*y + z*z == r2 );

	Manifold points_AA_GG = sphere .implicit ( x == y, x == z );
	Cell AA ( tag::vertex, tag::of_coords, { -0.5, -0.5, -0.5 }, tag::project );
	Cell GG ( tag::vertex, tag::of_coords, {  0.5,  0.5,  0.5 }, tag::project );

	Manifold points_BB_HH = sphere .implicit ( x + y == 0., x == z );
	Cell BB ( tag::vertex, tag::of_coords, { -0.5,  0.5, -0.5 }, tag::project );
	Cell HH ( tag::vertex, tag::of_coords, {  0.5, -0.5,  0.5 }, tag::project );

	Manifold points_CC_EE = sphere .implicit ( x == y, x + z == 0. );
	Cell CC ( tag::vertex, tag::of_coords, {  0.5,  0.5, -0.5 }, tag::project );
	Cell EE ( tag::vertex, tag::of_coords, { -0.5, -0.5,  0.5 }, tag::project );

	Manifold points_DD_FF = sphere .implicit ( x + y == 0, y == z );
	Cell DD ( tag::vertex, tag::of_coords, {  0.5, -0.5, -0.5 }, tag::project );
	Cell FF ( tag::vertex, tag::of_coords, { -0.5,  0.5,  0.5 }, tag::project );

	sphere .set_as_working_manifold();
	Mesh AABB = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( AA ) .stop_at ( BB ) .divided_in ( 15 );
	Mesh BBCC = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( BB ) .stop_at ( CC ) .divided_in ( 15 );
	Mesh CCDD = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( CC ) .stop_at ( DD ) .divided_in ( 15 );
	Mesh DDAA = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( DD ) .stop_at ( AA ) .divided_in ( 15 );
	Mesh AAEE = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( AA ) .stop_at ( EE ) .divided_in ( 15 );
	Mesh BBFF = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( BB ) .stop_at ( FF ) .divided_in ( 15 );
	Mesh CCGG = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( CC ) .stop_at ( GG ) .divided_in ( 15 );
	Mesh DDHH = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( DD ) .stop_at ( HH ) .divided_in ( 15 );
	Mesh EEFF = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( EE ) .stop_at ( FF ) .divided_in ( 15 );
	Mesh FFGG = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( FF ) .stop_at ( GG ) .divided_in ( 15 );
	Mesh GGHH = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( GG ) .stop_at ( HH ) .divided_in ( 15 );
	Mesh HHEE = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( HH ) .stop_at ( EE ) .divided_in ( 15 );

	Mesh ABCD_s = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
	  .faces ( AABB, BBCC, CCDD, DDAA );
	Mesh EFGH_s = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
	  .faces ( EEFF, FFGG, GGHH, HHEE );
	Mesh ADHE_s = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
	  .faces ( DDAA .reverse(), DDHH, HHEE, AAEE .reverse() );
	Mesh BAEF_s = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
	  .faces ( AABB .reverse(), AAEE, EEFF, BBFF .reverse() );
	Mesh CBFG_s = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
	  .faces ( BBCC .reverse(), BBFF, FFGG, CCGG .reverse() );
	Mesh DCGH_s = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
	  .faces ( CCDD .reverse(), CCGG, GGHH, DDHH .reverse() );

	// back to the torus (forget about the sphere manifold)
	torus_manif .set_as_working_manifold();
	
	Cell A ( tag::vertex );  x (A) = -1.;  y (A) = -1.;  z (A) = -1.;
	Cell B = A, C = A, D = A;
	Cell E ( tag::vertex );  x (E) = -1.;  y (E) = -1.;  z (E) =  1.;
	Cell F = E, G = E, H = E;

	Mesh AB = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( B ) .divided_in ( 15 ) .winding ( gy );
	Mesh BC = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( B ) .stop_at ( C ) .divided_in ( 15 ) .winding ( gx );
	Mesh CD = AB .reverse(), DA = BC .reverse();
	Mesh AE = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( E ) .divided_in ( 15 );
	Mesh BF = AE, CG = AE, DH = AE;
	Mesh EF = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( E ) .stop_at ( F ) .divided_in ( 15 ) .winding ( gy );
	Mesh FG = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( F ) .stop_at ( G ) .divided_in ( 15 ) .winding ( gx );
	Mesh GH = EF .reverse(), HE = FG .reverse();

	Mesh ABCD = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( AB, BC, CD, DA ) .winding();
	Mesh EFGH = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( EF, FG, GH, HE ) .winding();
	Mesh ADHE = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( DA .reverse(), DH, HE, AE .reverse() ) .winding();
	Mesh BAEF = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( AB .reverse(), AE, EF, BF .reverse() ) .winding();
	Mesh CBFG = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( BC .reverse(), BF, FG, CG .reverse() ) .winding();
	Mesh DCGH = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( CD .reverse(), CG, GH, DH .reverse() ) .winding();

	Mesh AAA = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( A ) .stop_at ( AA ) .divided_in ( 8 );
	Mesh BBB = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( B ) .stop_at ( BB ) .divided_in ( 8 ) .winding ( -gy );
	Mesh CCC = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( C ) .stop_at ( CC ) .divided_in ( 8 ) .winding ( -gx-gy );
	Mesh DDD = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( D ) .stop_at ( DD ) .divided_in ( 8 ) .winding ( -gx );
	Mesh EEE = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( E ) .stop_at ( EE ) .divided_in ( 8 );
	Mesh FFF = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( F ) .stop_at ( FF ) .divided_in ( 8 ) .winding ( -gy );
	Mesh GGG = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( G ) .stop_at ( GG ) .divided_in ( 8 ) .winding ( -gx-gy );
	Mesh HHH = Mesh::Build ( tag::grid ) .shape ( tag::segment )
		.start_at ( H ) .stop_at ( HH ) .divided_in ( 8 ) .winding ( -gx );

	Mesh AEEA = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( AE, EEE, AAEE .reverse(), AAA .reverse() ) .winding();
	Mesh BFFB = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( BF, FFF, BBFF .reverse(), BBB .reverse() ) .winding();
	Mesh CGGC = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( CG, GGG, CCGG .reverse(), CCC .reverse() ) .winding();
	Mesh DHHD = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( DH, HHH, DDHH .reverse(), DDD .reverse() ) .winding();
	Mesh ABBA = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( AB, BBB, AABB .reverse(), AAA .reverse() ) .winding();
	Mesh BCCB = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( BC, CCC, BBCC .reverse(), BBB .reverse() ) .winding();
	Mesh CDDC = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( CD, DDD, CCDD .reverse(), CCC .reverse() ) .winding();
	Mesh DAAD = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( DA, AAA, DDAA .reverse(), DDD .reverse() ) .winding();
	Mesh EFFE = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( EF, FFF, EEFF .reverse(), EEE .reverse() ) .winding();
	Mesh FGGF = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( FG, GGG, FFGG .reverse(), FFF .reverse() ) .winding();
	Mesh GHHG = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( GH, HHH, GGHH .reverse(), GGG .reverse() ) .winding();
	Mesh HEEH = Mesh::Build ( tag::grid ) .shape ( tag::quadrangle )
		.faces ( HE, EEE, HHEE .reverse(), HHH .reverse() ) .winding();

	Mesh cube_ABCD = Mesh::Build ( tag::grid ) .shape ( tag::parallelipiped )
		.faces ( ABCD, ABCD_s .reverse(), ABBA .reverse(),
		         CDDC .reverse(), DAAD .reverse(), BCCB .reverse() ) .winding();
	Mesh cube_EFGH = Mesh::Build ( tag::grid ) .shape ( tag::parallelipiped )
		.faces ( EFGH, EFGH_s .reverse(), EFFE .reverse(),
		         GHHG .reverse(), FGGF .reverse(), HEEH .reverse() ) .winding();
	Mesh cube_BAEF= Mesh::Build ( tag::grid ) .shape ( tag::parallelipiped )
		.faces ( BAEF, BAEF_s .reverse(), ABBA,
		         EFFE .reverse(), AEEA .reverse(), BFFB ) .winding();
	Mesh cube_CBFG = Mesh::Build ( tag::grid ) .shape ( tag::parallelipiped )
		.faces ( CBFG, CBFG_s .reverse(), BCCB,
		         FGGF .reverse(), BFFB .reverse(), CGGC ) .winding();
	Mesh cube_DCGH = Mesh::Build ( tag::grid ) .shape ( tag::parallelipiped )
		.faces ( DCGH, DCGH_s .reverse(), CDDC,
		         GHHG .reverse(), CGGC .reverse(), DHHD ) .winding();
	Mesh cube_ADHE = Mesh::Build ( tag::grid ) .shape ( tag::parallelipiped )
		.faces ( ADHE, ADHE_s .reverse(), DAAD,
		         HEEH .reverse(), DHHD .reverse(), AEEA ) .winding();

	std::cout << "built six 3D meshes, now joining" << std::endl;
	Mesh torus = Mesh::Build ( tag::join )
		.meshes ( { cube_ABCD, cube_EFGH .reverse(), cube_BAEF,
		            cube_CBFG, cube_DCGH, cube_ADHE            } );

	std::cout << "built 3D torus with round hole, total " << torus .number_of ( tag::cells_of_max_dim )
	          << " cubes, now unfolding" << std::endl;
	Mesh torus_unfolded = torus .unfold ( tag::over_region, x*x + 2*y*y + 3*z*z < 10, 5.*z + x < 0.4 );

	std::cout << "built unfolded mesh with " << torus_unfolded .number_of ( tag::cells_of_max_dim )
	          << " cubes, now exporting" << std::endl;
	torus_unfolded .export_to_file ( tag::gmsh, "torus-of-cubes.msh" );
	std::cout << "produced file torus-of-cubes.msh" << std::endl;

}  // end of main


